﻿# -*- coding: utf-8 -*-
import urlparse,urllib2,urllib,re
import os, sys
import json

from core import config
from core import logger
from core import scrapertools
from core import updater
from core.item import Item

DEBUG = True
CHANNELNAME = "channelselector"
DIRECTORIO_PATH_CONFIG= os.path.join( config.get_data_path() , 'channels')
PATH_LIST_CHANNELS_JSON= os.path.join( DIRECTORIO_PATH_CONFIG , "list_channels.json" )

def mainlist(params,url,category):
    logger.info("channelselector.mainlist")
    
    # Verifica actualizaciones solo en el primer nivel (actualizacion plugin)
    if config.get_platform()!="boxee":
        try:
            from core import updater
        except ImportError:
            logger.info("channelselector.mainlist No disponible modulo actualizaciones")
        else:
            if config.get_setting("updatecheck2") == "true":
                logger.info("channelselector.mainlist Verificar actualizaciones activado")
                #try:
                updater.checkforupdates()
                comparar_canales()
            else:
                logger.info("channelselector.mainlist Verificar actualizaciones desactivado")

       
    # Obtiene el idioma, y el literal
    idioma = config.get_setting("languagefilter")
    logger.info("channelselector.mainlist idioma=%s" % idioma)
    langlistv = [config.get_localized_string(30025),config.get_localized_string(30026),config.get_localized_string(30027),config.get_localized_string(30028),config.get_localized_string(30029)]
    try:
        idiomav = langlistv[int(idioma)]
    except:
        idiomav = langlistv[0]
    
    # Añade los canales que forman el menú principal
    itemlist = []
    itemlist.append( Item(title=config.get_localized_string(30118)+" ("+idiomav+")" , channel="channelselector" , action="listchannels", category='*', thumbnail = urlparse.urljoin(get_thumbnail_path(),"channelselector.png") ) ) # Canales
    itemlist.append( Item(title=config.get_localized_string(30119)+" ("+idiomav+")" , channel="channelselector" , action="channeltypes", thumbnail = urlparse.urljoin(get_thumbnail_path(),"channelselector.png") ) ) # Seleccione una categoria
    itemlist.append( Item(title=config.get_localized_string(30103) , channel="buscador" , action="mainlist" , thumbnail = urlparse.urljoin(get_thumbnail_path(),"buscador.png")) )
    itemlist.append( Item(title=config.get_localized_string(30128) , channel="trailertools" , action="mainlist" , thumbnail = urlparse.urljoin(get_thumbnail_path(),"trailertools.png")) )
    itemlist.append( Item(title=config.get_localized_string(30102) , channel="favoritos" , action="mainlist" , thumbnail = urlparse.urljoin(get_thumbnail_path(),"favoritos.png")) )
    if config.get_platform() in ("wiimc","rss") :itemlist.append( Item(title="Wiideoteca (Beta)" , channel="wiideoteca" , action="mainlist", thumbnail = urlparse.urljoin(get_thumbnail_path(),"wiideoteca.png")) )
    if config.get_platform()=="rss":itemlist.append( Item(title="pyLOAD (Beta)" , channel="pyload" , action="mainlist" , thumbnail = urlparse.urljoin(get_thumbnail_path(),"pyload.png")) )
    itemlist.append( Item(title=config.get_localized_string(30101) , channel="descargas" , action="mainlist", thumbnail = urlparse.urljoin(get_thumbnail_path(),"descargas.png")) )
    
    if "xbmceden" in config.get_platform():
        itemlist.append( Item(title=config.get_localized_string(30100) , channel="configuracion" , action="mainlist", thumbnail = urlparse.urljoin(get_thumbnail_path(),"configuracion.png"), folder=False) )
    else:
        itemlist.append( Item(title=config.get_localized_string(30100) , channel="configuracion" , action="mainlist", thumbnail = urlparse.urljoin(get_thumbnail_path(),"configuracion.png")) )

    if config.get_platform()!="rss": itemlist.append( Item(title=config.get_localized_string(30104) , channel="ayuda" , action="mainlist", thumbnail = urlparse.urljoin(get_thumbnail_path(),"ayuda.png")) )
     
    addfolder(itemlist)
  
def channeltypes(params,url,category):
    logger.info("channelselector.channeltypes")
    categoria=category.decode('latin1').encode('utf-8')
    
    itemlist = []
    itemlist.append( Item( title=config.get_localized_string(30121) , channel="channelselector" , action="listchannels" , category="*"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"channelselector")))
    itemlist.append( Item( title=config.get_localized_string(30122) , channel="channelselector" , action="listchannels" , category="F"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"peliculas")))
    itemlist.append( Item( title=config.get_localized_string(30123) , channel="channelselector" , action="listchannels" , category="S"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"series")))
    itemlist.append( Item( title=config.get_localized_string(30124) , channel="channelselector" , action="listchannels" , category="A"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"anime")))
    itemlist.append( Item( title=config.get_localized_string(30125) , channel="channelselector" , action="listchannels" , category="D"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"documentales")))
    itemlist.append( Item( title=config.get_localized_string(30136) , channel="channelselector" , action="listchannels" , category="VOS" , thumbnail=urlparse.urljoin(get_thumbnail_path(),"versionoriginal")))
    itemlist.append( Item( title=config.get_localized_string(30126) , channel="channelselector" , action="listchannels" , category="M"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"musica")))
    itemlist.append( Item( title=config.get_localized_string(30127) , channel="channelselector" , action="listchannels" , category="G"   , thumbnail=urlparse.urljoin(get_thumbnail_path(),"servidores")))
    #itemlist.append( Item( title=config.get_localized_string(30134) , channel="channelselector" , action="listchannels" , category="NEW" , thumbnail=urlparse.urljoin(get_thumbnail_path(),"novedades")))
        
    addfolder (itemlist)
        
def listchannels(params,url,category):
    logger.info("channelselector.listchannels") 
    lista = channels_list(category)
    addfolder(lista,category)
       
def channels_history_list():
    itemlist = []
    return itemlist

def channels_list(category='*'):
    langlistv = ["","ES","EN","IT","PT"] # Esto no me gusta mucho
    idioma = langlistv[int(config.get_setting("languagefilter"))]
    
    itemlist = []
    if category=='*': 
        itemlist.append( Item( viewmode="movie", title="Tengo una URL", channel="tengourl", language="", category="F,S,D,A", type="generic"))
    if config.get_setting("personalchannel")=="true":
        itemlist.append( Item( title=config.get_setting("personalchannelname"), channel="personal", action='mainlist', language="", category="*", type="generic",thumbnail= config.get_setting("personalchannellogo")))
    if config.get_setting("personalchannel2")=="true":
        itemlist.append( Item( title=config.get_setting("personalchannelname2"), channel="personal2", action='mainlist', language="", category="*", type="generic",thumbnail=config.get_setting("personalchannellogo2")))
    if config.get_setting("personalchannel3")=="true":
        itemlist.append( Item( title=config.get_setting("personalchannelname3"), channel="personal3", action='mainlist', language="", category="*", type="generic",thumbnail=config.get_setting("personalchannellogo3")))
    if config.get_setting("personalchannel4")=="true":
        itemlist.append( Item( title=config.get_setting("personalchannelname4"), channel="personal4", action='mainlist', language="", category="*", type="generic", thumbnail=config.get_setting("personalchannellogo4")))
    if config.get_setting("personalchannel5")=="true":
        itemlist.append( Item( title=config.get_setting("personalchannelname5"), channel="personal5", action='mainlist', language="", category="*", type="generic", thumbnail=config.get_setting("personalchannellogo5")))
    
    indice_canales= json.load(open(PATH_LIST_CHANNELS_JSON))
    for channel in sorted(indice_canales):
        
        # Control parental
        if config.get_setting("enableadultmode") == "false" and indice_canales[channel]['adult']=='true': continue 
        
        # Canales especiales (personal.py, libreria.py, etc..)
        if indice_canales[channel]['title']=='' or not(indice_canales[channel]['type'] == "generic" or indice_canales[channel]['type'] == "xbmc"): continue
        
        # Filtrado por categoria y añadimos plot
        categoria= indice_canales[channel]['category'].encode('utf8')
        if category<>"*" and category not in categoria: continue
        plot = categoria.replace("VOS","Versión original subtitulada").replace("F","Películas").replace("S","Series").replace("D","Documentales").replace("A","Anime").replace(",",", ")
        
        # Filtrado por idioma
        if indice_canales[channel]['language'] !='' and idioma !="" and idioma not in indice_canales[channel]['language']: continue
        
        # Añadimos el thumbnail
        thumbnail= indice_canales[channel]['thumbnail']
        if thumbnail=='':
            thumbnail=urlparse.urljoin(get_thumbnail_path(),indice_canales[channel]['channel'] +".png")
        
        itemlist.append(Item(title= indice_canales[channel]['title'], channel=indice_canales[channel]['channel'], action='mainlist', language=indice_canales[channel]['language'], category=categoria, type=indice_canales[channel]['type'], thumbnail= thumbnail, plot=plot)) 
        #logger.info("[channelselector] channel: " + str(channel))
    
    return itemlist
   
def read_remote_channels():
    remote_channel_url = "http://xbmc-tvalacarta.googlecode.com/svn/trunk/pelisalacarta/pelisalacarta/channels/"
    data = re.sub(r"\n|\r|\t|\s{2}|(<!--.*?-->)","",scrapertools.cache_page(remote_channel_url))
    
    patron = '<li><a href="([a-zA-Z0-9]+\.py)">.*?</a></li>'
    canales_remotos= re.compile(patron,re.DOTALL).findall(data)
        
    #logger.info("channelselector.read_remote_channels :"  + str(canales_remotos))
    return canales_remotos
    
def read_local_channels():    
    local_channel_path = os.path.join( config.get_runtime_path(), 'pelisalacarta/channels')
    canales_locales= os.listdir(local_channel_path)
    canales_locales= [c for c in canales_locales if c.endswith('.py') and not c.startswith('_')]
    
    #logger.info("channelselector.read_local_channels :"  + str(canales_locales))
    return canales_locales
    
def comparar_canales():
    canales_remotos= read_remote_channels()
    canales_locales= read_local_channels()
    lista_borrables=[]
    lista_nuevos=[]
      
    for channel in canales_remotos:
        if channel not in canales_locales:
            lista_nuevos.append(channel)
            dialogo('Nuevos canales', 'Añadiendo canal ' + channel.replace('.py','') )
            updater.download_channel(channel.replace('.py',''))
    
    logger.info("channelselector.comparar_canales Canales nuevos: "  + str(len(lista_nuevos))) 
    canales_locales.extend(lista_nuevos)
    
    # FALTA AÑADIR ESTE SETTING A LA CONFIGURACION GLOBAL
    #   <setting id="outsider_channel" type="enum" values="Mostrar|Ignorar|Eliminar" label="Acción con canales desconocidos" default="0"/>
    ''' Opciones para config.get_setting("outsider_channel")
        Opcion Mostrar (por defecto): config.get_setting("outsider_channel")=='0' Los canales seran mostrados en el menu como si estuviesen en SVN tambien. 
        Opcion Ignorar: config.get_setting("outsider_channel")=='1' Los canales no seran borrados, ni mostrados en el menu.
        Opcion Eliminar: config.get_setting("outsider_channel")=='2' Elimina todos los canales locales que no este subidos al SVN.
    '''
    for channel in canales_locales:
        if channel not in canales_remotos:
            if config.get_setting("outsider_channel")=="2":
                lista_borrables.append(channel)
                canales_locales.remove(channel)
                #Borra definitivamente el canal de nuestro HDD!!!
                os.remove(os.path.join(config.get_runtime_path(), 'pelisalacarta/channels',channel))
                if os.path.exists (os.path.join(config.get_runtime_path(), 'pelisalacarta/channels',channel.replace('.py','.pyo'))):
                    os.remove (os.path.join(config.get_runtime_path(), 'pelisalacarta/channels',channel.replace('.py','.pyo')))
                if os.path.exists (os.path.join(config.get_runtime_path(), 'pelisalacarta/channels',channel.replace('.py','.xml'))):
                    os.remove (os.path.join(config.get_runtime_path(), 'pelisalacarta/channels',channel.replace('.py','.xml')))
                if os.path.exists (os.path.join(DIRECTORIO_PATH_CONFIG,channel.replace('.py','.xml'))):
                    os.remove (os.path.join(DIRECTORIO_PATH_CONFIG,channel.replace('.py','.xml')))
            elif config.get_setting("outsider_channel")=='1':
                pass
            else:
                lista_nuevos.append(channel)
            
    logger.info("channelselector.comparar_canales Canales eliminados: "  + str(lista_borrables))        
    
    if not os.path.exists(PATH_LIST_CHANNELS_JSON): #si no existe el json creamos un obj diccionario para añadir todos los canales
        indice_canales= {}
        lista_nuevos = canales_locales
        
    if len(lista_nuevos) >0 or len(lista_borrables)>0:  
        logger.info("channelselector.comparar_canales editar " + PATH_LIST_CHANNELS_JSON)
        
        #Comprobamos si existe el directorio '\userdata\addon_data\plugin.video.pelisalacarta\channels' y si no lo creamos
        if not os.path.exists(DIRECTORIO_PATH_CONFIG):
            logger.info("[channelselector] Creando directorio "+ DIRECTORIO_PATH_CONFIG)
            os.mkdir(DIRECTORIO_PATH_CONFIG)
        
        if os.path.exists(PATH_LIST_CHANNELS_JSON): # Si existe list_channels.json lo abrimos...
            indice_canales= json.load(open(PATH_LIST_CHANNELS_JSON))
                  
        for c in lista_nuevos:
            # Abrir channel.py y buscar title, channel, language, category, type, adult y thumbnail
            indice_canales[c]= read_py(c)
            # Aunque creo q seria mejor pasar todos estos datos al channel.xml y hacer esto:
            # indice_canales[c]= read_xml(c)
            
        for c in lista_borrables:
            if c in indice_canales:
                del indice_canales[c]
            
        # Guardamos de nuevo list_channels.json
        with open(PATH_LIST_CHANNELS_JSON, 'w') as outfile:
            json.dump(indice_canales, outfile, sort_keys = True, indent = 4)
            outfile.close()
            
    logger.info("channelselector.comparar_canales Canales totales: "  + str(len(canales_locales)))

def read_py(file_channel_py):
    path_fichero_canal = os.path.join( config.get_runtime_path(), 'pelisalacarta' , 'channels' , file_channel_py )
    infile = open(path_fichero_canal)
    data = infile.read()
    infile.close()
    
    title= scrapertools.find_single_match(data,'__title__ = "([^"]+)"')
    channel= scrapertools.find_single_match(data,'__channel__ = "([^"]+)"')
    language= scrapertools.find_single_match(data,'__language__ = "([^"]+)"')
    category= scrapertools.find_single_match(data,'__category__ = "([^"]+)"')
    type= scrapertools.find_single_match(data,'__type__ = "([^"]+)"')
    adult= scrapertools.find_single_match(data,'__adult__ = "([^"]+)"')
    thumbnail= scrapertools.find_single_match(data,'__thumbnail__ = "([^"]+)"')
    
    return {"title": title, "channel":channel, "language":language, "category":category, "type":type, "adult":adult, "thumbnail":thumbnail}
           
def get_thumbnail_path():

    WEB_PATH = ""
    
    thumbnail_type = config.get_setting("thumbnail_type")
    if thumbnail_type=="":
        thumbnail_type="2"
    
    if thumbnail_type=="0":
        WEB_PATH = "http://pelisalacarta.mimediacenter.info/posters/"
    elif thumbnail_type=="1":
        WEB_PATH = "http://pelisalacarta.mimediacenter.info/banners/"
    elif thumbnail_type=="2":
        WEB_PATH = "http://pelisalacarta.mimediacenter.info/squares/"

    return WEB_PATH
    
def addfolder (itemlist, category=""):
    # Esta metodo solo sera compatible con xbmc
    import xbmc
    import xbmcgui
    import xbmcplugin
    
    for elemento in itemlist:
        #logger.info("channelselector.mainlist item="+elemento.title)
        if elemento.category == "":
            try:
                elemento.category = unicode( elemento.title, "utf-8" ).encode("iso-8859-1")
            except:
                pass
            
        listitem = xbmcgui.ListItem( elemento.title , iconImage="DefaultFolder.png", thumbnailImage=elemento.thumbnail)
        itemurl = '%s?channel=%s&action=%s&category=%s' % ( sys.argv[ 0 ] , elemento.channel , elemento.action , elemento.category )
        xbmcplugin.addDirectoryItem( handle = int(sys.argv[ 1 ]), url = itemurl , listitem=listitem, isFolder=elemento.folder)
        
    # Label (top-right)...
    xbmcplugin.setPluginCategory( handle=int( sys.argv[ 1 ] ), category=category )
    xbmcplugin.addSortMethod( handle=int( sys.argv[ 1 ] ), sortMethod=xbmcplugin.SORT_METHOD_NONE )
    xbmcplugin.endOfDirectory( handle=int( sys.argv[ 1 ] ), succeeded=True )

    if config.get_setting("forceview")=="true":
        # Confluence - Thumbnail
        xbmc.executebuiltin("Container.SetViewMode(500)")    
        
def dialogo(titulo, mensaje, icono= 0, tiempo=5000):
    # Esta metodo solo sera compatible con xbmc
    import xbmcgui
    dialog = xbmcgui.Dialog()
    l_icono=(xbmcgui.NOTIFICATION_INFO , xbmcgui.NOTIFICATION_WARNING, xbmcgui.NOTIFICATION_ERROR)
    dialog.notification(titulo, mensaje, l_icono[icono] ,tiempo)

